
package require tooltip
namespace eval ::tipstack {}
proc ::tipstack::push {args} {
    if {([llength $args] != 2) && (([llength $args] != 4))} {
	return -code error "wrong#args: expected w ?-index index? text"
    }
    set text [lindex $args end]
    set wref [lrange $args 0 end-1]
    variable db
    if {![info exists db($wref)]} {
	set db($wref) [list $text]
    } else {
	lappend db($wref) $text
    }
    eval [linsert [linsert $wref end $text] 0 tooltip::tooltip]
    return
}
proc ::tipstack::pop {args} {
    if {([llength $args] != 1) && (([llength $args] != 3))} {
	return -code error "wrong#args: expected w ?-index index?"
    }
    set wref $args
    variable db
    if {![info exists db($wref)]} {
	set text ""
    } else {
	set data $db($wref)
	if {[llength $data] == 1} {
	    set text [lindex $data 0]
	} else {
	    set data [lrange $data 0 end-1]
	    set text [lindex $data end]
	    set db($wref) $data
	}
    }
    eval [linsert [linsert $wref end $text] 0 tooltip::tooltip]
    return
}
proc ::tipstack::clear {args} {
    if {([llength $args] != 1) && (([llength $args] != 3))} {
	return -code error "wrong#args: expected w ?-index index?"
    }
    set wref $args
    variable db
    catch {unset db($wref)}
    eval [linsert [linsert $wref end ""] 0 tooltip::tooltip]
    return
}
proc ::tipstack::def {defs} {
    foreach {path text} $defs {
	push $path $text
    }
    return
}
proc ::tipstack::defsub {base defs} {
    foreach {subpath text} $defs {
	push $base$subpath $text
    }
    return
}
proc ::tipstack::clearsub {base} {
    variable db
    foreach k [array names db ${base}*] {
	clear $k
    }
    return
}
namespace eval ::tipstack {
    variable  db
    array set db {}
}
package provide tipstack 1.0
